unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, StdCtrls, ExtCtrls,
  UnitData, UnitFunc ;

type
  TForm1 = class(TForm)
    StringGrid1: TStringGrid;
    Label1: TLabel;
    Edit1: TEdit;
    Label2: TLabel;
    ComboBox1: TComboBox;
    RadioGroup1: TRadioGroup;
    Label3: TLabel;
    Edit2: TEdit;
    Label4: TLabel;
    Edit3: TEdit;
    Button1: TButton;
    Label5: TLabel;
    Edit4: TEdit;
    RadioGroup2: TRadioGroup;
    Label6: TLabel;
    Edit5: TEdit;
    Label7: TLabel;
    Edit6: TEdit;
    Label8: TLabel;
    Edit7: TEdit;
    Button2: TButton;
    ListBox1: TListBox;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure StringGrid1SetEditText(Sender: TObject; ACol, ARow: Integer;
      const Value: string);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
  private
    { Private 錾 }
    CData : TDataClass ;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

// N
procedure TForm1.FormShow(Sender: TObject);
begin
   with StringGrid1 do begin
      Cells[0, 0] := '' ;
      Cells[1, 0] := 'e' ;
      Cells[0, 1] := 'Ɩ' ;
      Cells[0, 2] := 'H' ;
      Cells[0, 3] := '_敪' ;
      Cells[0, 4] := '}ʖ' ;
      Cells[0, 5] := '}ʔԍ' ;
      Cells[0, 6] := '}ʎ' ;
      Cells[0, 7] := 'ړx' ;
      Cells[0, 8] := '}ʍ쐬Nij' ;
      Cells[0, 9] := '' ;
      Cells[0,10] := '' ;
      Cells[0,11] := '󒍉Ж' ;
      Cells[0,12] := 'ƎҖ' ;
   end;

   CData := TDataClass.Create ;
end;

// I
procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   CData.Free;
end;

procedure TForm1.StringGrid1SetEditText(Sender: TObject; ACol, ARow: Integer;
  const Value: string);
var
   i : integer ;
begin
   i := SInt(Value);

   Case (ARow) of
    1:   CData.zt.P_Name := Value ;
    2:   CData.zt.C_Name := Value ;
    3:   CData.zt.C_type := Value ;
    4:   CData.zt.D_title := Value ;
    5:   CData.zt.D_number := Value ;
    6:   CData.zt.C_type := Value ;
    7:   CData.zt.D_Scale := Value ;
    8:   CData.zt.D_Year := i;
    9:   CData.zt.D_Month := i ;
   10:   CData.zt.D_Day := i ;
   11:   CData.zt.C_Contractor := Value ;
   12:   CData.zt.C_Owner := Value ;
   End;
end;

// pݒOK
procedure TForm1.Button1Click(Sender: TObject);
var
   t,o,x,y : integer ;
begin
   t := ComboBox1.ItemIndex;
   if (t = -1) then begin
      ComboBox1.ItemIndex := 0 ;
      t := 0 ;
   end
   else if (t >= 0)and(t <= 4) then begin
      //
   end
   else if (t >= 8)and(t <= 26) then begin
      t := t - 8 + 10 ;
   end
   else if (t >= 28)and(t <= 34) then begin
      t := t - 28 + 30 ;
   end
   else begin
      t := 9 ;
   end;
   o := RadioGroup1.ItemIndex;
   x := SInt(Edit2.Text);
   y := SInt(Edit3.Text);
   with CData do begin
      zp.name := Edit1.Text;
      PaperSet(t,o,x,y);
   end;
end;

// Cǉo^
procedure TForm1.Button2Click(Sender: TObject);
var
   r : Boolean ;
   i : integer ;
begin
   r := CData.AddLayer(Edit4.Text,RadioGroup2.ItemIndex,
            SInt(Edit5.Text),SInt(Edit6.Text),SInt(Edit7.Text));
   if (r) then begin
      ListBox1.Items.Clear ;
      for i:=0 to CData.zLayN-1 do begin
         ListBox1.Items.Add(CData.zLay[i].name);
      end;
   end
   else
      ShowMessage('Cǉo^o܂ł');
end;

// CꗗNbNlmF
procedure TForm1.ListBox1Click(Sender: TObject);
var
   i : integer ;
begin
   if (ListBox1.Items.Count = 0) then exit;
   i := ListBox1.ItemIndex;
   if (i = -1) then exit;
   if (i >= CData.zLayN) then exit;
   with CData.zLay[i] do begin
      Edit4.Text := name ;
      RadioGroup2.ItemIndex := Lflag ;
      Edit5.Text := IntToStr(Color);
      Edit6.Text := IntToStr(LType);
      Edit7.Text := IntToStr(Width);
   end;
end;

end.
