unit UnitData;

interface

uses
   UnitFunc ;

const
   LAYER_MAX_NUM = 256 ;   // Cő吔
   COLOR_MAX_NUM = 256 ;   // F@ő吔
   LTYPE_MAX_NUM =  32 ;   // ő吔
   WIDTH_MAX_NUM =  16 ;   // ő吔

type
   TZumenTitle = record       // }ʏb}ʕ\藓
      P_Name : string;        // Ɩ
      C_Name : string;        // H
      C_type : string;        // _敪
      D_title : string;       // }ʖ
      D_number : string;      // }ʔԍ
                              // }ʔԍ + $$ + }ʐō\B$$ȍ~̓IvV
      D_type : string;        // }ʎ
      D_Scale : string;       // ړx
      D_Year : integer;       // }ʍ쐬Nij
      D_Month : integer;      // V     112
      D_Day : integer;        // V     131
      C_Contractor : string;  // 󒍉Ж
      C_Owner : string;       // ƎҖ
   end;

   TZumenPaper = record       // }ʍ\bp
      name : string;          // }ʖ
      typ : integer;          // pTCY(0:A0, 1:A1, 2:A2, 3:A3, 4:A4, 9:FREE)
      orient : integer;       // c^敪(0:c,1:)
      x : integer;            // Rp(Pmm)
      y : integer;            // Rpc(Pmm)
   end;

   TZumenLayer = record       // }ʍ\bC
      exf   : Boolean ;       // ݃tO True:L False:
      name  : string;         // }ʖ
      Lflag : Integer ;       // 0:\ 1:\
      Color : Integer ;       // CF
      Ltype : Integer ;       // C
      Width : Integer ;       // C
      cnt   : Integer ;       // Cvf
   end;

   TDataClass = class
   public
      { Public 錾 }
      zt : TZumenTitle;    // }ʏb}ʕ\藓
      zp : TZumenPaper;    // }ʍ\bp
      zLay : array of TZumenLayer;     // }ʍ\bC
      zLayN: Integer ;                 // C
      zColN: Integer ;                 // F
      zLtpN: Integer ;                 // 퐔
      zWidN: Integer ;                 // 
      constructor Create;
      destructor Free;
      procedure DataInit;
      function  StrCheck(s:string) : Boolean;
      procedure PaperSet(t,o,x,y:integer);
      function  LayerNameCheck(s:string) : Integer;
      function  AddLayer(s:string;fla,col,ltp,wid:integer) : Boolean;
      function  EditLayer(n:integer;s:string;fla,col,ltp,wid:integer) : Boolean;
      function  DeleteLayer(n:integer) : Boolean;
   private
      { Private 錾 }
   end;

implementation

// 
constructor TDataClass.Create;
begin
   DataInit ;
end;

// 
destructor TDataClass.Free;
begin
   DataInit ;
end;

// lZbg
procedure TDataClass.DataInit;
begin
   // 񒷂0偁(NULL)͋Ȃ̂Ŕp󔒂܂
   with zt do begin
      P_Name   := ' ';
      C_Name   := ' ';
      C_type   := ' ';
      D_title  := ' ';
      D_number := ' ';
      D_type   := ' ';
      D_Scale  := '1/1';
      D_Year   := 2011;
      D_Month  := 1;
      D_Day    := 1;
      C_Contractor := ' ';
      C_Owner  := ' ';
   end;
   with zp do begin
      name  := ' ';
      typ   := 0;
      orient:= 1;
      x     := 1189;
      y     := 841;
   end;
   zLay  := nil;
   zLayN := 0;
   zColN := 16;
   zLtpN := 15;
   zWidN := 9;
end;

// `FbN
//    (ret) OK : True  NG : False
//     0񒷁256 ǂ`FbN
function TDataClass.StrCheck(s:string) : Boolean;
var
   t : AnsiString ;
   l : integer ;
begin
   t := AnsiString(s) ;
   l := Length(t) ;
   if (l > 0) and (l <= 256) then
      Result := True
   else
      Result := False ;
end;

// pTCYZbg
//    t : (0:A0, 1:A1, 2:A2, 3:A3, 4:A4, 9:FREE)
//          {(10:A0~2 11:A0~3 12:A1~3 13:A1~4 14:A2~3 15:A2~4 16:A2~5
//             17:A3~3 18:A3~4 19:A3~5 20:A3~6 21:A3~7 22:A4~3 23:A4~4
//             24:A4~5 25:A4~6 26:A4~7 27:A4~8 28:A4~9)
//          {(30:B0 31:B1 32:B2 33:B3 34:B4 35:B5 36:B6)
//    o : c^敪(0:c,1:)
//    x : Rp(Pmm) t=9̎Ɏw
//    y : Rpc(Pmm) t=9̎Ɏw
procedure TDataClass.PaperSet(t,o,x,y:integer);
begin
   case(t)of
   0: begin
         x := 1189;
         y :=  841;
      end;
   1: begin
         x := 841;
         y := 594;
      end;
   2: begin
         x := 594;
         y := 420;
      end;
   3: begin
         x := 420;
         y := 297;
      end;
   4: begin
         x := 297;
         y := 210;
      end;
   10:begin // A0~2
         x := 1682;
         y := 1189;
      end;
   11:begin // A0~3
         x := 2523;
         y := 1189;
      end;
   12:begin // A1~3
         x := 1783;
         y :=  841;
      end;
   13:begin // A1~4
         x := 2378;
         y :=  841;
      end;
   14:begin // A2~3
         x := 1261;
         y :=  594;
      end;
   15:begin // A2~4
         x := 1682;
         y :=  594;
      end;
   16:begin // A2~5
         x := 2102;
         y :=  594;
      end;
   17:begin // A3~3
         x :=  891;
         y :=  420;
      end;
   18:begin // A3~4
         x := 1189;
         y :=  420;
      end;
   19:begin // A3~5
         x := 1486;
         y :=  420;
      end;
   20:begin // A3~6
         x := 1783;
         y :=  420;
      end;
   21:begin // A3~7
         x := 2080;
         y :=  420;
      end;
   22:begin // A4~3
         x :=  630;
         y :=  297;
      end;
   23:begin // A4~4
         x :=  841;
         y :=  297;
      end;
   24:begin // A4~5
         x := 1051;
         y :=  297;
      end;
   25:begin // A4~6
         x := 1261;
         y :=  297;
      end;
   26:begin // A4~7
         x := 1471;
         y :=  297;
      end;
   27:begin // A4~8
         x := 1682;
         y :=  297;
      end;
   28:begin // A4~9
         x := 1892;
         y :=  297;
      end;
   30:begin // B0
			x := 1456;
			y := 1028;
      end;
   31:begin // B1
			x := 1028;
			y :=  728;
      end;
   32:begin // B2
			x := 728;
			y := 514;
      end;
   33:begin // B3
			x := 514;
			y := 364;
      end;
   34:begin // B4
         x := 364;
			y := 257;
      end;
   35:begin // B5
         x := 257;
			y := 182;
      end;
   36:begin // B6
			x := 182;
			y := 128;
      end;
   end;
   if (t >= 0)and(t <= 4) then begin
      if (o = 0) then
         swapI(x,y)
      else
         o := 1;  // CM[lłꍇɔ
   end
   else if (t >= 10)and(t <= 28)
         or(t >= 30)and(t <= 36) then begin
      t := 9 ;
      if (o = 0) then
         swapI(x,y)
      else
         o := 1;
   end
   else begin
      t := 9 ;
      if (x < 100) then x := 100 ;   // RTCY̏ꍇ̒l`FbN
      if (y < 100) then y := 100 ;   //    100mm`10000mmƂĂ
      if (x > 10000) then x := 10000 ;
      if (y > 10000) then y := 10000 ;
      // p̌
      if (x >= y) then
         o := 1
      else
         o := 0 ;
   end;

   zp.typ      := t ;
   zp.orient   := o ;
   zp.x        := x ;
   zp.y        := y ;
end;

// w肵C̃Cԍ擾
//    s  : C
// (ret) 1`256FCԍ@0:o^
//    xPlA擪32oCgŃ`FbN
//    C̏d`FbNɂp
function TDataClass.LayerNameCheck(s:string) : Integer;
var
   i,j : integer;
   s1,s2 : AnsiString ;
begin
   Result := 0 ;
   s1 := AnsiString(s) ;
   s1 := MidStr2(s1,1,32,j);
   for i:=0 to zLayN-1 do begin
      if not(zLay[i].exf) then continue;  // ݂Ȃ̂ŃX[
      s2 := AnsiString(zLay[i].name) ;
      s2 := MidStr2(s2,1,32,j);
      if (s1 = s2) then begin
         Result := i + 1;
         break ;
      end;
   end;
end;

// C@f[^ڂ̒ǉo^
//    s  : C
//    fla: \tO(0,1)
//    col: CF  (1-256)
//    ltp: C(1-32)
//    wid: C(1-16)
// (ret) True:o^OK@False:NG
function TDataClass.AddLayer(s:string;fla,col,ltp,wid:integer) : Boolean;
var
   i,j : integer;
begin
   Result := False;
   if not(StrCheck(s)) then exit;         // 񐔃`FbN
   if (LayerNameCheck(s) > 0) then exit;  // ɃC͎gp
   if (zLayN = LAYER_MAX_NUM) then begin
      // Cő吔܂ōs폜CTĕҏW
      j := -1;
      for i:=0 to zLayN-1 do begin
         if (zLay[i].exf) then continue ; // ݃C̓X[
         j := i ;
         break ;
      end;
      if (j = -1) then exit ; // ȏヌC͓o^s
      Result := EditLayer(j+1, s,fla,col,ltp,wid);
      if (Result) then begin
         with zLay[j] do begin
            exf := True ;
            cnt := 0 ;
         end;
      end;
      exit;
   end;

   if (fla <> 0) then fla := 1;
   if (col < 1)or(col > zColN) then col := 1;
   if (ltp < 1)or(ltp > zLtpN)or(ltp = 16) then ltp := 1;
   if (wid < 1)or(wid > zWidN) then wid := 1;

   Inc(zLayN);
   SetLength(zLay, zLayN);
   with zLay[zLayN-1] do begin
      exf   := True ;
      name  := s ;
      Lflag := fla ;
      Color := col ;
      Ltype := ltp ;
      Width := wid ;
      cnt   := 0 ;
   end;
   Result := True ;
end;

// C@f[^ڂ̕ҏWo^
//    n  : Cԍ(1-256)
//    s  : C
//    fla: \tO(0,1)
//    col: CF  (1-256)
//    ltp: C(1-32)
//    wid: C(1-16)
// (ret) True:o^OK@False:NG
function TDataClass.EditLayer(n:integer;s:string;fla,col,ltp,wid:integer) : Boolean;
var
   e : Boolean ;
begin
   Result := False;
   if (n < 1)or(n > zLayN) then exit;     // CԍG[
   if not(StrCheck(s)) then exit;         // 񐔃`FbN
   e := zLay[n-1].exf ;
   zLay[n-1].exf := False;                // g̖O`FbNȂ悤
   if (LayerNameCheck(s) > 0) then begin
      zLay[n-1].exf := e;
      exit;  // ɃC͎gp
   end;
   zLay[n-1].exf := e;

   if (fla <> 0) then fla := 1;
   if (col < 1)or(col > zColN) then col := 1;
   if (ltp < 1)or(ltp > zLtpN)or(ltp = 16) then ltp := 1;
   if (wid < 1)or(wid > zWidN) then wid := 1;

   with zLay[n-1] do begin
      name  := s ;
      Lflag := fla ;
      Color := col ;
      Ltype := ltp ;
      Width := wid ;
   end;
   Result := True ;
end;

// C@f[^ڂ̍폜
//    n  : Cԍ(1-256)
// (ret) True:폜OK@False:NG
//    폜ƂĂA݃tOItɂ邾ł
//    Cvf 0 ̏ꍇ̂ݍ폜\ł
function TDataClass.DeleteLayer(n:integer) : Boolean;
begin
   Result := False;
   if (n < 1)or(n > zLayN) then exit;     // CԍG[
   if not(zLay[n-1].exf) then exit;       // ɍ폜ς
   if (zLay[n-1].cnt > 0) then exit;      // Cɗvf̂ō폜s

   zLay[n-1].exf := False;
   Result := True;
end;

end.
